
' Hardware:
' Start der Uhr durch Reset- Taster
' Buzzer an PB 4
' Stundenvorwahl (Startzeit) durch 3 Schalter an PB0, PB1, PB2 jeweils gegen Masse
'
' Test-Version 1200: RC- Oszillator;  Takt mit Clkpr auf 9,6 / 256 herabgesetzt

'----------------------------------------------------------
$regfile = "attiny13.dat"
$crystal = 37500                                            ' 9,6 MHz / 256


$hwstack = 32                                               ' nur max. 4 Unterprogramme + Interrupt, spart SRAM
$swstack = 0                                                ' wird nicht bentigt, spart SRAM
$framesize = 0

On Timer0 Ontimer0                                          'Interrupt-Routine


'Variablen

Dim T As Word                                               ' 1/2 Sekunden
Dim Q As Byte                                               ' aufsummierte Haslbstunden
Dim V As Byte                                               ' Halbstunden fr Gongausgabe
Dim H As Byte                                               ' Stunden
Dim N As Byte                                               ' wird in Zhlschleife verwendet                                             ' Aktueller Morsebuchstabe


' Konstanten

Const Dit1 = 32                                             ' Laenge Sound
Const Dit2 = 18
Const Tonhoehe1 = 2
Const Tonhoehe2 = 4


'- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
' Variablen dimensionieren:


Acsr.7 = 1                                                  ' Analog-Komparator ausschalten, spart etwas Strom
Sreg.7 = 1                                                  ' Global Interrupt Enable

 Ddrb = &B0001_0000                                         ' alle Pins Eingang bis auf PB4
 Portb = &B0000_1111                                        ' alle Pins Pullup-Widerstand bis auf PB4


 '----------------------------------------------------------

'
' Timer 0 macht 1 Interrupt / sec:
Config Timer0 = Timer , Prescale = 256
Enable Timer0
Start Timer0

Buzzer Alias Portb.4

Clkpr = &B10000000                                          ' nderung Clockteiler vorbereiten
Clkpr = &B00001000                                          ' 9600000 / 64
Clkpr = &B10001000


'Q = 80                                                      ' durch Reset Uhr auf 20:00 Uhr einstellen (Tagesschau- Zeitsignal ;-)

'                                                            ' Alternative: Startzeit mit Dip- Schalter vorwhlen
Q = Not Pinb                                                ' Invertieren, da gesetzter Schalter -> 0
Q = Q And &B000_0111                                        ' Bit 0 bis 2 filtern  ->  Q = 0 ... 7
Shift Q , Left , 1                                          ' Verdoppeln; Q = 0,2 , 4 .... 14
Q = Q + 10                                                  ' 10 ... 24       -> 5:00 bis 12:00 Uhr

Goto Einsprung:


Do                                                          'Hauptschleife

     If T > 29 Then                                         ' Testbetrieb 30 sek statt 30 min
'    If T > 1799 Then                                            ' Realbetrieb halbe Stunde ist um
        T = 0
        Incr Q                                              '
        If Q > 24 Then                                      ' 12 Stunden um ; Stunden Uhr auf 0 stellen
           Q = 1
        End If

Einsprung:

       H = Q / 2                                            ' Stunden =  aufsummierte Halbstunden / 2
       V = Q Mod 2                                          ' Rest Stunden


' auszugebende Gongschlaege:


        If V = 1 Then                                       ' Halbe Stunde
           Gosub Gong

        Else

           For N = 1 To H

              Gosub Gong
              Waitms 200
              Gosub Gong
              Wait 1
           Next

        End If
     End If

     Idle

Loop



Gong:

          Sound Buzzer , Dit1 , Tonhoehe1
          Sound Buzzer , Dit2 , Tonhoehe2

Return





'----------------------------------------------------------


Ontimer0:                                                   'Timer1-Overflow-Interrupt-Routine

   Tcnt0 = 113                                              ' Preset auf 110, damit er 146 Takte bis Ueberlauf zhlt
   Incr T                                                   ' also 1 Int/sec bei 37,5 kHz und Vorteiler / 256
Return
