
' Hardware:
' Start der Uhr durch Reset- Taster
' Takt durch externen Quarzoszillator mit 3,6864 MHz an PB3
' Buzzer an PB 4
' Stundenvorwahl (Startzeit) durch 3 Schalter an PB0, PB1, PB2 jeweils gegen Masse
'
' Mit 3.686400 MHz- Quarz und Vorteiler 1/8 : 2 Interrupts /sec
'
' Version 1200: RC- Oszillator;  Takt mit Clkpr auf 9,6 / 256 herabgesetzt

'----------------------------------------------------------
$regfile = "attiny13.dat"
$crystal = 37500                                            ' 9,6 MHz / 256


$hwstack = 40                                               ' nur max. 4 Unterprogramme + Interrupt, spart SRAM
$swstack = 0                                                ' wird nicht bentigt, spart SRAM
$framesize = 0

On Timer0 Ontimer0                                          'Interrupt-Routine


'Variablen

Dim T As Word                                               ' 1/2 Sekunden
Dim Q As Byte                                               ' aufsummierte Viertelstunden
Dim V As Byte                                               ' Viertelstunden fr Morseausgabe
Dim H As Byte                                               ' Stunden
Dim Z As Byte                                               ' Zehnerstelle Stunden
Dim E As Byte                                               ' Einerstelle Stunden

Dim I As Byte                                               ' wird in Zhlschleife verwendet
Dim N As Word                                               ' Aktueller Morsebuchstabe
Dim M As Byte                                               ' wird frs Auslesen der Morsebits verwendet



' Konstanten
                                 ' Tonhhe

Const Dit = 40                                              ' Laenge eines Punkts, daraus ergibt sich die Morsegeschwindigkeit
Const Dah = Dit * 3                                         ' Laenge eines Strichs
Const Dit_pause = Dit * 3 / 4
Const Dah_pause = Dit_pause * 5
Const Wort_pause = Dit_pause * 8                            ' Lnge der Pause zwischen Wrtern
Const Tonhoehe = 4


'- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
' Variablen dimensionieren:


Acsr.7 = 1                                                  ' Analog-Komparator ausschalten, spart etwas Strom
Sreg.7 = 1                                                  ' Global Interrupt Enable

 Ddrb = &B0001_0001                                         ' alle Pins Eingang bis auf PB4

 Portb = &B0000_1111                                        ' alle Pins Pullup-Widerstand bis auf PB4


 '----------------------------------------------------------

'
' Timer 0 macht 2 Interrupts / sec:
Config Timer0 = Timer , Prescale = 256
Enable Timer0
Start Timer0

Buzzer Alias Portb.0

Clkpr = &B10000000                                          ' nderung Clockteiler vorbereiten
Clkpr = &B00001000                                          ' 9600000 / 64
Clkpr = &B10001000


'Q = 80                                                      ' durch Reset Uhr auf 20:00 Uhr einstellen (Tagesschau- Zeitsignal ;-)

'                                                            ' Alternative: Startzeit mit Dip- Schalter vorwhlen
Q = Not Pinb                                                ' Invertieren, da gesetzter Schalter -> 0
Q = Q And &B000_0111                                        ' Bit 0 bis 2 filtern  ->  Q = 1 ... 7
Shift Q , Left , 2                                          ' Q  = 0, 4, 8, .... 28
Q = 52 + Q                                                  ' Q = 52, 56 ....80   ->  Startzeit  13, 14 .... 20 Uhr

Goto Einsprung:


Do                                                          'Hauptschleife

       If T > 15 Then                                       ' Testbetrieb 15 sek statt 15 min
'     If T > 119 Then                                        ' Testbetrieb 1 min statt Viertelstunde
'    If S > 1799 Then                                            ' Realbetrieb Viertelstunde ist um
        T = 0
        Incr Q                                              '
        If Q = 96 Then                                      ' Tageswechsel; Uhr auf 00 stellen
           Q = 0
        End If

Einsprung:

       H = Q / 4                                            ' Stunden =  aufsummierte Viertelstunden / 4
       V = Q Mod 4                                          ' Rest Viertelstunden
       Z = H / 10                                           ' Zehnerstelle Stunden
       E = H Mod 10                                         ' Einerstelle Stunden


' auszugebende Morsezeichen:

       Select Case V

         Case 0:                                            ' volle Stunde

            For N = 10 To 16                                ' String "es ist "
               Gosub Morse
            Next
            If Z > 0 Then                                   ' Zehnerstelle ausgeben, wenn ungleich Null
               N = Z
               Gosub Morse
            End If
            N = E                                           ' Einerstelle ausgeben
            Gosub Morse
            For N = 16 To 19                                ' string " uhr"
               Gosub Morse
            Next

         Case 1:                                            ' 15. Minute

             N = 1
            Gosub Morse
            N = 5
            Gosub Morse

         Case 2:                                            ' 30. Minute

            N = 3
            Gosub Morse
            N = 0
            Gosub Morse


         Case 3:                                            ' 45. Minute
            N = 4
            Gosub Morse
            N = 5
            Gosub Morse

       End Select

   End If

   Idle

Loop





 ' Morsezeichenerzeugung:


Morse:

    M = Lookup(n , Tdata)


     If M = 0 Then                                          ' Sonderfall: Leerzeichen;
        Waitms Wort_pause
        Goto Sign_end
     End If

     For I = 1 To 8
       If M = 1 Then                                        ' Das Byte hat nur noch den Wert 1; Zeichenende!
          Goto Sign_end
       End If
       If M.0 = 1 Then                                      ' ist Bit.0 = 1   -> dah
           Sound Buzzer , Dah , Tonhoehe
         Else
           Sound Buzzer , Dit , Tonhoehe                    ' ist das Bit 0 -> dit
       End If
       Waitms Dit_pause                                     ' Pause innerhalb des Morsezeichens
       Shift M , Right , 1                                  ' Bits um eine Stelle nach rechts shiften
     Next I
     Sign_end:
     Waitms Dah_pause                                       ' Pause zwischen Morsezeichen
   Return

End


'----------------------------------------------------------


Ontimer0:                                                   'Timer1-Overflow-Interrupt-Routine

   Tcnt0 = 110                                              ' Preset auf 31, damit er 225 Takte bis Ueberlauf zhlt
'   Tcnt0 = 22
   Incr T
Return






'- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
' Codierung der Morsezeichen. Bei einem Prozessor mit viel SRAM wrde man alle Zeichen
' in ein Array einlesen (bersetzungstabelle), den eigentlichen Bakentext in einen String packen
' und diesen String zeichenenweise abarbeiten.
'
' Da der Attiny13 nur ca. 64 Byte SRAM hat, ist nur Platz fr etwa 50 Bytes. Daher ist der Weg hier
' anders:  Der Bakentext ist ein Array mit max. 52 Elementen, in dem die auszusendenden Zeichen stehen
' allerdings in einer leicht lesbaren schreibweise.
' Die bersetzungstabelle ist mit Konstanten realisiert. Nur die wirklich bentigten
' Zeichen werden (beim kompilieren des Programmes) umgewandelt.


Const #a = &B00000110
Const #b = &B00010001
Const #c = &B00010101
Const #d = &B00001001
Const #e = &B00000010
Const #f = &B00010100
Const #g = &B00001011
Const #h = &B00010000
Const #i = &B00000100
Const #j = &B00011110
Const #k = &B00001101
Const #l = &B00010010
Const #m = &B00000111
Const #n = &B00000101
Const #o = &B00001111
Const #p = &B00010110
Const #q = &B00011011
Const #r = &B00001010
Const #s = &B00001000
Const #t = &B00000011
Const #u = &B00001100
Const #v = &B00011000
Const #w = &B00001110
Const #x = &B00011001
Const #y = &B00011101
Const #z = &B00010011
Const #ae = &B00011010
Const #oe = &B00010111
Const #ue = &B00011100
Const #0 = &B00111111
Const #1 = &B00111110
Const #2 = &B00111100
Const #3 = &B00111000
Const #4 = &B00110000
Const #5 = &B00100000
Const #6 = &B00100001
Const #7 = &B00100011
Const #8 = &B00100111
Const #9 = &B00101111

Const Leerz = 0
Const Anfuehrz = &B01010010
Const Kl_auf = &B00101101
Const Kl_zu = &B01101101
Const Plus = &B00101010
Const Komma = &B01110011
Const Minus = &B01100001
Const Punkt = &B01101010
Const Slash = &B00101001
Const Dopp_pkt = &B01000111
Const Gleich = &B00110001
Const Fragez = &B01001100
Const Ende = 255



Tdata:
Data #0 , #1 , #2 , #3 , #4 , #5 , #6 , #7 , #8 , #9

Data #e , #s , Leerz , #i , #s , #t , Leerz , #u , #h , #r