
' Hardware:
' Start der Uhr durch Reset- Taster
' Buzzer an PB 4
' Halb- Stundenvorwahl (Startzeit) durch 3 Schalter an PB0, PB1, PB2 jeweils gegen Masse
'
' Test- Version 1200: RC- Oszillator;  Takt mit Clkpr auf 9,6 / 256 herabgesetzt

'----------------------------------------------------------
$regfile = "attiny13.dat"
$crystal = 37500                                            ' 9,6 MHz / 256


$hwstack = 40
$swstack = 8
$framesize = 8

On Timer0 Ontimer0                                          'Interrupt-Routine


'Variablen

Dim T As Word                                               ' Sekunden
Dim Q As Byte                                               ' aufsummierte Haslbstunden
Dim V As Byte                                               ' Halbstunden fr Gongausgabe
Dim H As Byte                                               ' Stunden
Dim N As Word                                               ' wird in Zhlschleife verwendet


' Konstanten

Const Dit1 = 32                                             ' Laenge Sound
Const Dit2 = 18
Const Tonhoehe1 = 2
Const Tonhoehe2 = 4



' Register:

Acsr.7 = 1                                                  ' Analog-Komparator ausschalten, spart etwas Strom
Sreg.7 = 1                                                  ' Global Interrupt Enable

Ddrb = &B0001_0000                                          ' alle Pins Eingang bis auf PB4
Portb = &B0000_1111                                         ' alle Pins Pullup-Widerstand bis auf PB4


'----------------------------------------------------------

'
' Timer 0 macht 1 Interrupt / sec:

Config Timer0 = Timer , Prescale = 256
Enable Timer0
Start Timer0

Buzzer Alias Portb.4

Clkpr = &B10000000                                          ' nderung Clockteiler vorbereiten
Clkpr = &B00001000                                          ' 9600000 / 256
Clkpr = &B10001000


                                                            ' Startzeit mit Dip- Schalter vorwhlen
Q = Not Pinb                                                ' Invertieren, da gesetzter Schalter -> 0
Q = Q And &B000_0111                                        ' Bit 0 bis 2 filtern  ->  Q = 1 ... 7
If Q = 0 Then
   Q = 8
End If

Goto Einsprung:


Do                                                          'Hauptschleife

     If T > 14 Then                                         ' Testbetrieb 15 sek statt 30 min
'    If T > 899 Then                                        ' Realbetrieb halbe Stunde ist um
        T = 0
        Incr Q                                              '
        If Q > 8 Then                                       ' Wachwechsel; Uhr auf 00 stellen
           Q = 1
        End If

Einsprung:

       H = Q / 2                                            ' Stunden =  aufsummierte Halbstunden / 2
       V = Q Mod 2                                          ' Rest Stunden


' auszugebende Gongschlaege:


        If V = 1 Then                                       ' halbe Stunde
           Gosub Gong
        End If

        Wait 1

        For N = 1 To H                                      ' volle Stunden

           Gosub Gong
           Waitms 200
           Gosub Gong
           Waitms 800
        Next

     End If

     Idle

Loop



Gong:

          Sound Buzzer , Dit1 , Tonhoehe1
          Sound Buzzer , Dit2 , Tonhoehe2

Return





'----------------------------------------------------------


Ontimer0:                                                   'Timer1-Overflow-Interrupt-Routine

   Tcnt0 = 112                                              ' Preset auf 110, damit er 146 Takte bis Ueberlauf zhlt
   Incr T                                                   ' also 1 Int/sec bei 37,5 kHz und Vorteiler / 256
Return